//autocomplete code - protagonist.co.uk (ben jennings) 2005
//updated 11-07-2011 for lion fix charcode
//code to do the tag autocomplete

var tagStore = new Array;
var tagLookup = new Array;
var autoMenu = new Array;
var storage = "";
var selected = 0;

var ref = document.getElementById('tags'); //setup the listener
var temp = document.getElementById('test');

//XML REQUEST
function getTags() {
    progInd.start();
    userFeedback('loading tags', 'feedback');
    var username = window.document.getElementById('username').value;
    var password = window.document.getElementById('password').value;
    if (username == "") {
        // console.error("no username");
        userFeedback('no username', 'feedback');
    } else if (password == "") {
        // console.error("no password");
        userFeedback('no password', 'feedback');
    } else {
        url = "https://" + username + ":" + password + "@api.del.icio.us/v1/tags/get?";
        tagXML = new XMLHttpRequest();
        tagXML.onreadystatechange = tagDone;
        tagXML.open("GET", url, true);
        tagXML.overrideMimeType('text/xml');
        tagXML.send(null)
    }
}

function tagDone() {
    if (tagXML.readyState==4) {
        if (tagXML.status == 200) {
            //alert('200');
            //userFeedback('status: 200');
        } 
        if (tagXML.status == 503) {
            //alert('503');
            //userFeedback('status: 203');
        } 
        if (tagXML.status == 500) {
            //alert('500');
            //userFeedback('status: 500');
        }
        else {
            //userFeedback('tags loaded', 'feedback');
            tagData = tagXML.responseXML.documentElement;
            var length = tagData.getElementsByTagName('tag').length;
            for (i = 0; i <= length - 1; i++) {
                tagStore[i] = tagData.getElementsByTagName('tag')[i].getAttribute('tag');
            }   
            tagStore.sort();
            for (i = 0; i <= tagStore.length - 1; i++) {
                tagLookup[i] = i;
            }
            userFeedback('', 'feedback');
            progInd.stop();
        }
    }
}

//DEALS WITH DICTIONARY
function autoTag(){ //setup renamed to autoTag to make nice with AppleClass
    // console.log("autoTag called...");
    getTags();
    pageLoad();
}

//KEYBOARD CODE
function pageLoad() {
    var e = document.getElementById("tags");
    
    e.addEventListener("keyup", handleKeyPress, false); // looks like the bug is here
    e.addEventListener("keydown", handleKeyDown, false);
}

function handleKeyDown(e) {
    var ref = document.getElementById('tags'); //setup the listener 
    if (e.charCode == 38) { //63232 // up arrow
        e.preventDefault();
    }
}

function handleKeyPress(e) {
    var ref = document.getElementById('tags'); //setup the listener
    //if (e.stopPropagation) e.stopPropagation(); //kills keyboard repeat

    switch (e.keyCode) {
        case 27: // escape key
            // console.log(autoMenu);
            break;
        case 40: // down arrow hit
            // console.log("down arrow");
            e.preventDefault();
            if (selected < (autoMenu.length - 1) && selected <= 3) {
                ++selected;
                feedback();
            }
            break;
        case 38: // up arrow hit
            // console.log("up arrow");
            e.preventDefault();
            if (selected > 0) {
                --selected;
                feedback();
            }
            break;
        case 9: // tab key
            // console.log("tab");
            break;
        case 17: // control key
            // console.log("control key");
            break;
        case 13: // return key
            // console.log("return key");
            if (ref.value == "" || floater.style.display == 'none') { //the nothing case test

            } else if (ref.value.lastIndexOf(" ") == -1) { //for only one word      
                ref.value = autoMenu[selected];
                ref.value = ref.value + "";
                end = ref.value.length;
                ref.setSelectionRange(end, end);
            } else { //for multiple words
                tempstore = ref.value.substring(0, ref.value.lastIndexOf(" "));
                testForNull = ref.value.substring(ref.value.lastIndexOf(" "), ref.value.length);
                if (testForNull != " ") { //this is in case the user hits return with a space
                    ref.value = tempstore + " " + autoMenu[selected];
                    ref.value = ref.value + "";
                    end = ref.value.length;
                    ref.setSelectionRange(end, end);
                }
            }
            floater.style.display = 'none';
            submitButton.style.display = 'block';
            break;
        default:
            complete(e);
            break;
    }
}

function complete(event) { //gets the bit of the string that needs completing
    selected = 0;
    var ref = document.getElementById('tags');
    var space = ref.value.lastIndexOf(" ");

    if (space == -1) { //only one word
        autocomplete(ref.value);
    } else { //multiple words

        var sending = ref.value.slice(space + 1, ref.value.length);
        if (sending != "") { //to deal with no content to avoid a javascript error

            autocomplete(sending);
        } else { //to deal with multiple words when the user deletes
            floater.style.display = 'none';
            submitButton.style.display = 'block';
        }
    }
}

function autocomplete(keyboard) { //
    //alert("autocomplete called");
    autoMenu.splice(0, autoMenu.length); //recreate the menu lookup
    for (i = 0; i <= (tagLookup.length - 1); i++) {
        lookup = tagStore[tagLookup[i]];
        temp1 = keyboard;
        temp2 = lookup.slice(0, keyboard.length);
        if (temp2 == temp1) {
            autoMenu.push(lookup);
        }       
    }   
    feedback(); //used to have storage in
}

function feedback() { //used to have input - makes the drop down menu
    var ref = document.getElementById('tags');
    var space = ref.value.lastIndexOf(" ");
    var secondTest = 0;

    if (space != -1 && ref.value.slice(space + 1, ref.value.length).length >= 0) {
        floater.style.display = 'none';
        submitButton.style.display = 'block';
    } else if (space != -1){
        floater.style.display = 'none';
        submitButton.style.display = 'block';
    }

    if (ref.value != "" || space != -1) { //test to make sure there is some content in there
        var genMenu = ""; //reset array
        //alert("automenu: " + autoMenu.length);
        if (autoMenu.length - 1 >= 4) { //this is because of the limited size
            menuLength = 5;
        } else {
            menuLength = autoMenu.length - 1;
        }
        //alert(menuLength);
        for (i = 0; i <= autoMenu.length - 1; i++) {
            if (i == selected) {
                genMenu = genMenu + "<div class='menu1'>" + autoMenu[i] + "</div>";
            } else {
                genMenu = genMenu + "<div class='menu2'>" + autoMenu[i] + "</div>";
            }
        }
        if (genMenu != "") {
            floater.style.display = 'block';
            submitButton.style.display = 'none';
            document.getElementById('floater').innerHTML = genMenu;
        } else {        
            floater.style.display = 'none';
            submitButton.style.display = 'block';
            selected = 0;
        }
    } else {
        floater.style.display = 'none';
        submitButton.style.display = 'block';
    }
}
//TAG CHECK
function tagCheck() {
    //alert('tagCheck called');
    var ref = document.getElementById('tags'); //setup the listener
    var splitString = ref.value.split(" ");
    var splitTest = new Array;
    for (i = 0; i <= splitString.length - 1; i++) { //big loop to test again existing tags
        for (j = 0; j <= tagStore.length - 1; j++) {
            if (splitString[i] == tagStore[j]) {
                splitTest[i] = 1; //this is a positive
            }
        }
    }
    var output = "";
    for (i = 0; i <= splitString.length - 1; i++) {
        if (splitTest[i] == 1) { //already in there
            output = output + " inthere ";
        } else { //not in there
            output = output + " new: " + splitString[i];
            tagStore.push(splitString[i]);
        }
    }
    tagStore.sort(); //resort the tagStore list to save the del.icio.us servers :)
    for (i = 0; i <= tagStore.length - 1; i++) {
        tagLookup[i] = i;
    }
}

//OTHER
function formCheck() { //this is to force a delay
    answer = true;
    answer = false;
    return answer;
}